/// Created by Arsenii Kirillov
 
#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#ifndef LOCAL
#  define cerr __get_ce
#endif
 
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
 
/*
using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;
//*/
 
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }
 
void solve() {
	int n, m, k;
	cin >> n >> m >> k;
	vector<string> s(n);
	vector<int> xx(k), yy(k);
	int sx = -1, sy = -1, fx = -1, fy = -1;
	for (int i = 0; i < n; i++) {
		cin >> s[i];
		for (int j = 0; j < m; j++) {
			if (s[i][j] == 'S') {
				sx = i;
				sy = j;
			}
			if (s[i][j] == 'F') {
				fx = i;
				fy = j;
			}
		}
	}
	for (int i = 0; i < k; i++) {
		cin >> xx[i] >> yy[i];
		xx[i]--;
		yy[i]--;
	}
	auto check = [&](int x, int y) {
		return x >= 0 && x < n && y >= 0 && y < m && s[x][y] != '#';
	};
	int dx[4] = {1, 0, -1, 0};
	int dy[4] = {0, 1, 0, -1};
	vector<vector<int>> d(n, vector<int>(m, INF));
	auto bfs = [&](int x, int y) {
		for (int i = 0; i < n; i++)
			fill(all(d[i]), INF);
		d[x][y] = 0;
		queue<pair<int, int>> que;
		que.push({x, y});
		while (que.size()) {
			int x = que.front().first;
			int y = que.front().second;
			que.pop();
			for (int i = 0; i < 4; i++) {
				if (check(x + dx[i], y + dy[i]) && d[x + dx[i]][y + dy[i]] > d[x][y] + 1) {
					d[x + dx[i]][y + dy[i]] = d[x][y] + 1;
					que.push({x + dx[i], y + dy[i]});
				}
			}
		}
	};
	bfs(sx, sy);
	if (k == 0) {
		if (d[fx][fy] == INF)
			d[fx][fy] = -1;
		cout << d[fx][fy] << endl;
		return;
	}
	vector<vector<int>> dp(k, vector<int>(4, INF));
	for (int i = 0; i < 4; i++)
		if (check(xx[0] + dx[i], yy[0] + dy[i]))
			dp[0][i] = d[xx[0] + dx[i]][yy[0] + dy[i]];
	for (int i = 0; i + 1 < k; i++) {
		for (int j = 0; j < 4; j++) {
			if (check(xx[i] + dx[j], yy[i] + dy[j])) {
				bfs(xx[i] + dx[j], yy[i] + dy[j]);
				for (int q = 0; q < 4; q++)
					if (check(xx[i + 1] + dx[q], yy[i + 1] + dy[q]))
						dp[i + 1][q] = min(dp[i + 1][q], dp[i][j] + d[xx[i + 1] + dx[q]][yy[i + 1] + dy[q]]);
			}
		}
	}
	bfs(fx, fy);
	int ans = INF;
	for (int i = 0; i < 4; i++)
		if (check(xx[k - 1] + dx[i], yy[k - 1] + dy[i]))
			ans = min(ans, dp[k - 1][i] + d[xx[k - 1] + dx[i]][yy[k - 1] + dy[i]]);
	if (ans == INF)
		ans = -1;
	cout << ans << endl;
}
 
 
int main() {
#ifdef LOCAL
	clock_t start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
 
	int test_count = 1;
	//cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
 
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}