// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;


int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = opt<int>(1);
	int m = opt<int>(2);
	int k = opt<int>(3);

	vector<vector<bool>> field(n, vector<bool>(m));

	for (int i = 0; i < k; ++i) {
		int t = rnd.next(0, 1);
		if (t == 0) {
			int x = rnd.next(0, n - 1);
			int y1 = rnd.next(0, m - 1);
			int y2 = rnd.next(0, m - 1);
			if (y1 > y2) {
				swap(y1, y2);
			}
			for (int y = y1; y <= y2; ++y) {
				field[x][y] = true;
			}
		} else {
			int y = rnd.next(0, m - 1);
			int x1 = rnd.next(0, n - 1);
			int x2 = rnd.next(0, n - 1);
			if (x1 > x2) {
				swap(x1, x2);
			}
			for (int x = x1; x <= x2; ++x) {
				field[x][y] = true;
			}
		}
	}

	cout << n << " " << m << "\n";
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (!field[i][j]) {
				cout << ".";
			} else {
				cout << rnd.next(0, 9);
			}
		}
		cout << "\n";
	}

	return 0;
}